//////////////////////////////////////////////////////////////////
// mysql JDBC Driver
//
// Version : 0.9.2
//
// JDBC : 1.22
//
// LastModified: 12.03.1997
//
// Copyright (c) 1997 GWE Technologies Ltd. All rights reserved
// See http://gwe.co.uk/mysql/jdbc/copyright.html for full details

namespace gwe.sql {

using System;

[Serializable]
public class gweMysqlColumn {
  string tableName;
  string columnName;
  int columnLength;
  int columnType;
  short columnFlag;
  int columnDecimals;

  public gweMysqlColumn(string t, string n, int l, int tp, short f, int d) {
    tableName=t;
    columnName=n;
    columnLength=l;
    columnType=tp;
    columnFlag=f;
    columnDecimals=d;
  }

  public string getTable() {
    return tableName;
  }
  public string getName() {
    return columnName;
  }
  public string getFullName() {
    string fullName=string.Concat(tableName, ".");
    return string.Concat(fullName, columnName);
  }
  public int getLength() {
    return columnLength;
  }
  public int getType() {
    return columnType;
  }
  public int getDecimals() {
    return columnDecimals;
  }
  public bool isNotNull() {
    if ((columnFlag&1)>0)
      return true;
    else
      return false;
  }
  public bool isPrimaryKey() {
    if ((columnFlag&2)>0)
      return true;
    else
      return false;
  }
  public bool isUniqueKey() {
    if ((columnFlag&4)>0)
      return true;
    else
      return false;
  }
  public bool isMultipleKey() {
    if ((columnFlag&8)>0)
      return true;
    else
      return false;
  }
  public bool isBlob() {
    if ((columnFlag&16)>0)
      return true;
    else
      return false;
  }
  public bool isUnsigned() {
    if ((columnFlag&32)>0)
      return true;
    else
      return false;
  }
  public bool isZeroFill() {
    if ((columnFlag&64)>0)
      return true;
    else
      return false;
  }
  public bool isPartKey() {
    if ((columnFlag&128)>0)
      return true;
    else
      return false;
  }
  // Thanks for INDEN-san
  public bool isBinary() {
    if ((columnFlag&128)>0)
      return true;
    else
      return false;
  }

  //// for Serialization
  //private void writeObject(ObjectOutputStream oos) throws IOException {
  //  oos.defaultWriteObject();
  //}
  //private void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException {
  //  ois.defaultReadObject();
  //}
}

}
