//////////////////////////////////////////////////////////////////
// mysql JDBC Driver
//
// Version : 0.9.2
//
// JDBC : 1.22
//
// LastModified: 12.03.1997
//
// Copyright (c) 1997 GWE Technologies Ltd. All rights reserved
// See http://gwe.co.uk/mysql/jdbc/copyright.html for full details

package gwe.sql;

import javax.naming.Name;
import javax.naming.Context;
import java.util.Hashtable;
import javax.naming.spi.ObjectFactory;
import javax.naming.Reference;

public class gweMysqlConnectionPoolDataSourceFactory implements ObjectFactory {

  private static final String dsName = "gwe.sql.gweMysqlConnectionPoolDataSource";

  public Object getObjectInstance(Object obj, Name name,
                                  Context nameCtx, Hashtable environment)
                                                           throws Exception {
    if( obj != null && obj instanceof Reference )
    {
      Reference ref_obj = (Reference)obj;
      if( !ref_obj.getClassName().equals(dsName) )
        return null;

      gwe.sql.gweMysqlConnectionPoolDataSource cpds =
          (gwe.sql.gweMysqlConnectionPoolDataSource)Class.forName(dsName).newInstance();

      cpds.setNetworkProtocol((String)ref_obj.get("networkProtocol").getContent());
      cpds.setServerName((String)ref_obj.get("serverName").getContent());
      cpds.setPortNumber(new Integer((String)ref_obj.get("portNumber").getContent()));
      cpds.setDatabaseName((String)ref_obj.get("databaseName").getContent());
      cpds.setUser((String)ref_obj.get("user").getContent());
      cpds.setPassword((String)ref_obj.get("password").getContent());
      cpds.setCharacterEncoding((String)ref_obj.get("characterEncoding").getContent());
      cpds.setNativeUnicodeMapper((String)ref_obj.get("nativeUnicodeMapper").getContent());
      cpds.setAdd5CAfter5C(new Boolean((String)ref_obj.get("add5CAfter5C").getContent()));
      cpds.setMaxPoolSize(new Integer((String)ref_obj.get("maxPoolSize").getContent()));
      cpds.setUseNewIO(new Boolean((String)ref_obj.get("useNewIO").getContent()));
      cpds.setDebugSQL(new Boolean((String)ref_obj.get("debugSQL").getContent()));

      return cpds;
    }
    return null;
  }
}