//////////////////////////////////////////////////////////////////
// mysql JDBC Driver
//
// Version : 0.9.2
//
// JDBC : 1.22
//
// LastModified: 12.03.1997
//
// Copyright (c) 1997 GWE Technologies Ltd. All rights reserved
// See http://gwe.co.uk/mysql/jdbc/copyright.html for full details

package gwe.sql;

import javax.naming.Name;
import javax.naming.Context;
import java.util.Hashtable;
import javax.naming.spi.ObjectFactory;
import javax.naming.Reference;

public class gweMysqlDataSourceFactory implements ObjectFactory {

  private static final String dsName = "gwe.sql.gweMysqlDataSource";

  public Object getObjectInstance(Object obj, Name name,
                                  Context nameCtx, Hashtable environment)
                                                           throws Exception {
    if( obj != null && obj instanceof Reference )
    {
      Reference ref_obj = (Reference)obj;
      if( !ref_obj.getClassName().equals(dsName) )
        return null;

      gwe.sql.gweMysqlDataSource ds =
               (gwe.sql.gweMysqlDataSource)Class.forName(dsName).newInstance();

      ds.setNetworkProtocol((String)ref_obj.get("networkProtocol").getContent());
      ds.setServerName((String)ref_obj.get("serverName").getContent());
      ds.setPortNumber(new Integer((String)ref_obj.get("portNumber").getContent()));
      ds.setDatabaseName((String)ref_obj.get("databaseName").getContent());
      ds.setUser((String)ref_obj.get("user").getContent());
      ds.setPassword((String)ref_obj.get("password").getContent());
      ds.setCharacterEncoding((String)ref_obj.get("characterEncoding").getContent());
      ds.setNativeUnicodeMapper((String)ref_obj.get("nativeUnicodeMapper").getContent());
      ds.setAdd5CAfter5C(new Boolean((String)ref_obj.get("add5CAfter5C").getContent()));
      ds.setUseNewIO(new Boolean((String)ref_obj.get("useNewIO").getContent()));
      ds.setDebugSQL(new Boolean((String)ref_obj.get("debugSQL").getContent()));

      return ds;
    }
    return null;
  }
}
