//////////////////////////////////////////////////////////////////
// mysql JDBC Driver
//
// Version : 0.9.2
//
// JDBC : 1.22
//
// LastModified: 12.03.1997
//
// Copyright (c) 1997 GWE Technologies Ltd. All rights reserved
// See http://gwe.co.uk/mysql/jdbc/copyright.html for full details

namespace gwe.sql {

using System;
using System.Collections;
using net.sql;
using netx.sql;

public class gweMysqlPooledConnection : PooledConnection, Connection {

  private Connection org_conn = null;
  private gweMysqlConnectionPoolDataSource pool = null;

  public gweMysqlPooledConnection(gweMysqlConnectionPoolDataSource pool,
                                  Connection org_conn) {
    this.pool = pool;
    this.org_conn = org_conn;
  }

  public override int GetHashCode() {
    return org_conn.GetHashCode();
  }

  public override bool Equals(object obj) {
    if( obj != null && obj is gweMysqlPooledConnection )
    {
      gweMysqlPooledConnection that = (gweMysqlPooledConnection)obj;
      return (this.org_conn == that.org_conn);
    }
    return false;
  }

  public void close() {
    //org_conn.close();
    pool.storeConnection(this);
  }

  internal Connection getOrgConnection() {
    return org_conn;
  }

  public Connection getConnection() {
    return this;
  }

  public bool isClosed() {
    //boolean retval = org_conn.isClosed();
    return org_conn == null;
  }

  public void addConnectionEventListener(ConnectionEventListener parm1) {
    ;
  }

  public void removeConnectionEventListener(ConnectionEventListener parm1) {
    ;
  }

  public Statement createStatement() {
    Statement retval = org_conn.createStatement();
    return retval;
  }
  public PreparedStatement prepareStatement(string sql) {
    PreparedStatement retval = org_conn.prepareStatement(sql);
    return retval;
  }
  public CallableStatement prepareCall(string sql) {
    CallableStatement retval = org_conn.prepareCall(sql);
    return retval;
  }
  public string nativeSQL(string sql) {
    string retval = org_conn.nativeSQL(sql);
    return retval;
  }
  public void setAutoCommit(bool autoCommit) {
    org_conn.setAutoCommit(autoCommit);
  }
  public bool getAutoCommit() {
    bool retval = org_conn.getAutoCommit();
    return retval;
  }
  public void commit() {
    org_conn.commit();
  }
  public void rollback() {
    org_conn.rollback();
  }
  public DatabaseMetaData getMetaData() {
    DatabaseMetaData retval = org_conn.getMetaData();
    return retval;
  }
  public void setReadOnly(bool readOnly) {
    org_conn.setReadOnly(readOnly);
  }
  public bool isReadOnly() {
    bool retval = org_conn.isReadOnly();
    return retval;
  }
  public void setCatalog(string catalog) {
    org_conn.setCatalog(catalog);
  }
  public string getCatalog() {
    string retval = org_conn.getCatalog();
    return retval;
  }
  public void setTransactionIsolation(int level) {
    org_conn.setTransactionIsolation(level);
  }
  public int getTransactionIsolation() {
    int retval = org_conn.getTransactionIsolation();
    return retval;
  }
  public SQLWarning getWarnings() {
    SQLWarning retval = org_conn.getWarnings();
    return retval;
  }
  public void clearWarnings() {
    org_conn.clearWarnings();
  }
  public Statement createStatement(int resultSetType, int resultSetConcurrency) {
    Statement retval = org_conn.createStatement(resultSetType, resultSetConcurrency);
    return retval;
  }
  public PreparedStatement prepareStatement(string sql, int resultSetType, int resultSetConcurrency) {
    PreparedStatement retval = org_conn.prepareStatement(sql, resultSetType, resultSetConcurrency);
    return retval;
  }
  public CallableStatement prepareCall(string sql, int resultSetType, int resultSetConcurrency) {
    CallableStatement retval = org_conn.prepareCall(sql, resultSetType, resultSetConcurrency);
    return retval;
  }
  public Hashtable getTypeMap() {
    Hashtable retval = org_conn.getTypeMap();
    return retval;
  }
  public void setTypeMap(Hashtable map) {
    org_conn.setTypeMap(map);
  }

  //------------------------- JDBC 3.0 -----------------------------------

  public void setHoldability(int holdability) {
    org_conn.setHoldability(holdability);
  }
  public int getHoldability() {
    int retval = org_conn.getHoldability();
    return retval;
  }
  public Savepoint setSavepoint() {
    Savepoint retval = org_conn.setSavepoint();
    return retval;
  }
  public Savepoint setSavepoint(string name) {
    Savepoint retval = org_conn.setSavepoint(name);
    return retval;
  }
  public void rollback(Savepoint savepoint) {
    org_conn.rollback(savepoint);
  }
  public void releaseSavepoint(Savepoint savepoint) {
    org_conn.releaseSavepoint(savepoint);
  }
  public Statement createStatement(int resultSetType, int resultSetConcurrency,
                                   int resultSetHoldability) {
    Statement retval = org_conn.createStatement(resultSetType,
                                   resultSetConcurrency, resultSetHoldability);
    return retval;
  }
  public PreparedStatement prepareStatement(String sql, int resultSetType,
                                      int resultSetConcurrency, int resultSetHoldability)
                                                              {
    PreparedStatement retval = org_conn.prepareStatement(sql, resultSetType,
                                   resultSetConcurrency, resultSetHoldability);
    return retval;
  }
  public CallableStatement prepareCall(string sql, int resultSetType,
                                      int resultSetConcurrency, int resultSetHoldability)
                                                              {
    CallableStatement retval = org_conn.prepareCall(sql, resultSetType,
                                   resultSetConcurrency, resultSetHoldability);
    return retval;
  }
  public PreparedStatement prepareStatement(string sql, int autoGeneratedKeys)
                                                              {
    PreparedStatement retval = org_conn.prepareStatement(sql, autoGeneratedKeys);
    return retval;
  }
  public PreparedStatement prepareStatement(string sql, int[] columnIndexes)
                                                              {
    PreparedStatement retval = org_conn.prepareStatement(sql, columnIndexes);
    return retval;
  }
  public PreparedStatement prepareStatement(string sql, string[] columnNames)
                                                              {
    PreparedStatement retval = org_conn.prepareStatement(sql, columnNames);
    return retval;
  }
}

}
