//////////////////////////////////////////////////////////////////
// mysql JDBC Driver
//
// Version : 0.9.2
//
// JDBC : 1.22
//
// LastModified: 12.03.1997
//
// Copyright (c) 1997 GWE Technologies Ltd. All rights reserved
// See http://gwe.co.uk/mysql/jdbc/copyright.html for full details

package gwe.sql;

import javax.naming.Name;
import javax.naming.Context;
import java.util.Hashtable;
import javax.naming.spi.ObjectFactory;
import javax.naming.Reference;

public class gweMysqlXADataSourceFactory implements ObjectFactory {

  private static final String dsName = "gwe.sql.gweMysqlXADataSource";

  public Object getObjectInstance(Object obj, Name name,
                                  Context nameCtx, Hashtable environment)
                                                           throws Exception {
    if( obj != null && obj instanceof Reference )
    {
      Reference ref_obj = (Reference)obj;
      if( !ref_obj.getClassName().equals(dsName) )
        return null;

      gwe.sql.gweMysqlXADataSource xads =
                 (gwe.sql.gweMysqlXADataSource)Class.forName(dsName).newInstance();

      xads.setNetworkProtocol((String)ref_obj.get("networkProtocol").getContent());
      xads.setServerName((String)ref_obj.get("serverName").getContent());
      xads.setPortNumber(new Integer((String)ref_obj.get("portNumber").getContent()));
      xads.setDatabaseName((String)ref_obj.get("databaseName").getContent());
      xads.setUser((String)ref_obj.get("user").getContent());
      xads.setPassword((String)ref_obj.get("password").getContent());
      xads.setCharacterEncoding((String)ref_obj.get("characterEncoding").getContent());
      xads.setNativeUnicodeMapper((String)ref_obj.get("nativeUnicodeMapper").getContent());
      xads.setAdd5CAfter5C(new Boolean((String)ref_obj.get("add5CAfter5C").getContent()));
      xads.setMaxPoolSize(new Integer((String)ref_obj.get("maxPoolSize").getContent()));
      xads.setDebugSQL(new Boolean((String)ref_obj.get("debugSQL").getContent()));

      return xads;
    }
    return null;
  }
}
