namespace net.sql {

public interface CallableStatement : PreparedStatement {

  // throws SQLException
  void registerOutParameter(int parameterIndex, int sqlType);

  // throws SQLException
  void registerOutParameter(int parameterIndex, int sqlType, int scale);

  // throws SQLException
  bool wasNull();

  // throws SQLException
  string getString(int parameterIndex);

  // throws SQLException
  bool getbool(int parameterIndex);

  // throws SQLException
  sbyte getByte(int parameterIndex);

  // throws SQLException
  short getShort(int parameterIndex);

  // throws SQLException
  int getInt(int parameterIndex);

  // throws SQLException
  long getLong(int parameterIndex);

  // throws SQLException
  float getFloat(int parameterIndex);

  // throws SQLException
  double getDouble(int parameterIndex);

  // throws SQLException
  System.Decimal getBigDecimal(int parameterIndex, int scale);

  // throws SQLException
  sbyte[] getBytes(int parameterIndex);

  // throws SQLException
  System.DateTime getDate(int parameterIndex);

  // throws SQLException
  System.DateTime getTime(int parameterIndex);

  // throws SQLException
  System.DateTime getTimestamp(int parameterIndex);

  // throws SQLException
  object getObject(int parameterIndex);

  // throws SQLException
  System.Decimal getBigDecimal(int parameterIndex);

  // throws SQLException
  object getObject(int i, System.Collections.Hashtable map);

  // throws SQLException
  Ref getRef(int i);

  // throws SQLException
  Blob getBlob(int i);

  // throws SQLException
  Clob getClob(int i);

  // throws SQLException
  Array getArray(int i);

  // throws SQLException
  System.DateTime getDate(int parameterIndex, System.Globalization.Calendar cal);

  // throws SQLException
  System.DateTime getTime(int parameterIndex, System.Globalization.Calendar cal);

  // throws SQLException
  System.DateTime getTimestamp(int parameterIndex, System.Globalization.Calendar cal);

  // throws SQLException
  void registerOutParameter(int paramIndex, int sqlType, string typeName);

  // throws SQLException
  void registerOutParameter(string parameterName, int sqlType);

  // throws SQLException
  void registerOutParameter(string parameterName, int sqlType, int scale);

  // throws SQLException
  void registerOutParameter(string parameterName, int sqlType, string typeName);

  // throws SQLException
  string getURL(int parameterIndex);

  // throws SQLException
  void setURL(string parameterName, string val);

  // throws SQLException
  void setNull(string parameterName, int sqlType);

  // throws SQLException
  void setBoolean(string parameterName, bool x);

  // throws SQLException
  void setByte(string parameterName, sbyte x);

  // throws SQLException
  void setShort(string parameterName, short x);

  // throws SQLException
  void setInt(string parameterName, int x);

  // throws SQLException
  void setLong(string parameterName, long x);

  // throws SQLException
  void setFloat(string parameterName, float x);

  // throws SQLException
  void setDouble(string parameterName, double x);

  // throws SQLException
  void setBigDecimal(string parameterName, System.Decimal x);

  // throws SQLException
  void setString(string parameterName, string x);

  // throws SQLException
  void setBytes(string parameterName, sbyte[] x);

  // throws SQLException
  void setDate(string parameterName, System.DateTime x);

  // throws SQLException
  void setTime(string parameterName, System.DateTime x);

  // throws SQLException
  void setTimestamp(string parameterName, System.DateTime x);

  // throws SQLException
  void setAsciiStream(string parameterName, System.IO.BinaryReader x, int length);

  // throws SQLException
  void setBinaryStream(string parameterName, System.IO.BinaryReader x,
                       int length);

  // throws SQLException
  void setObject(string parameterName, object x, int targetSqlType, int scale);

  // throws SQLException
  void setObject(string parameterName, object x, int targetSqlType);

  // throws SQLException
  void setObject(string parameterName, object x);

  // throws SQLException
  void setCharacterStream(string parameterName,
                          System.IO.StreamReader reader,
                          int length);

  // throws SQLException
  void setDate(string parameterName, System.DateTime x, System.Globalization.Calendar cal);

  // throws SQLException
  void setTime(string parameterName, System.DateTime x, System.Globalization.Calendar cal);

  // throws SQLException
  void setTimestamp(string parameterName, System.DateTime x, System.Globalization.Calendar cal);

  // throws SQLException
  void setNull (string parameterName, int sqlType, string typeName);

  // throws SQLException
  string getString(string parameterName);

  // throws SQLException
  bool getbool(string parameterName);

  // throws SQLException
  sbyte getByte(string parameterName);

  // throws SQLException
  short getShort(string parameterName);

  // throws SQLException
  int getInt(string parameterName);

  // throws SQLException
  long getLong(string parameterName);

  // throws SQLException
  float getFloat(string parameterName);

  // throws SQLException
  double getDouble(string parameterName);

  // throws SQLException
  sbyte[] getBytes(string parameterName);

  // throws SQLException
  System.DateTime getDate(string parameterName);

  // throws SQLException
  System.DateTime getTime(string parameterName);

  // throws SQLException
  System.DateTime getTimestamp(string parameterName);

  // throws SQLException
  object getObject(string parameterName);

  // throws SQLException
  System.Decimal getBigDecimal(string parameterName);

  // throws SQLException
  object getobject(string parameterName, System.Collections.Hashtable map);

  // throws SQLException
  Ref getRef(string parameterName);

  // throws SQLException
  Blob getBlob(string parameterName);

  // throws SQLException
  Clob getClob(string parameterName);

  // throws SQLException
  Array getArray(string parameterName);

  // throws SQLException
  System.DateTime getDate(string parameterName, System.Globalization.Calendar cal);

  // throws SQLException
  System.DateTime getTime(string parameterName, System.Globalization.Calendar cal);

  // throws SQLException
  System.DateTime getTimestamp(string parameterName, System.Globalization.Calendar cal);

  // throws SQLException
  string getURL(string parameterName);
}

}
