namespace net.sql {

public enum Connection_TRANSACTION {
  NONE             = 0,
  READ_UNCOMMITTED = 1,
  READ_COMMITTED   = 2,
  REPEATABLE_READ  = 4,
  SERIALIZABLE     = 8,
}

public interface Connection {

  // throws SQLException
  Statement createStatement();

  // throws SQLException
  PreparedStatement prepareStatement(string sql);

  // throws SQLException
  CallableStatement prepareCall(string sql);

  // throws SQLException
  string nativeSQL(string sql);

  // throws SQLException
  void setAutoCommit(bool autoCommit);

  // throws SQLException
  bool getAutoCommit();

  // throws SQLException
  void commit();

  // throws SQLException
  void rollback();

  // throws SQLException
  void close();

  // throws SQLException
  bool isClosed();

  // throws SQLException
  DatabaseMetaData getMetaData();

  // throws SQLException
  void setReadOnly(bool readOnly);

  // throws SQLException
  bool isReadOnly();

  // throws SQLException
  void setCatalog(string catalog);

  // throws SQLException
  string getCatalog();

  // throws SQLException
  void setTransactionIsolation(int level);

  // throws SQLException
  int getTransactionIsolation();

  // throws SQLException
  SQLWarning getWarnings();

  // throws SQLException
  void clearWarnings();

  // throws SQLException
  Statement createStatement(int resultSetType, int resultSetConcurrency);

  // throws SQLException
  PreparedStatement prepareStatement(string sql, int resultSetType,
                                     int resultSetConcurrency);

  // throws SQLException
  CallableStatement prepareCall(string sql, int resultSetType,
                                int resultSetConcurrency);

  // throws SQLException
  System.Collections.Hashtable getTypeMap();

  // throws SQLException
  void setTypeMap(System.Collections.Hashtable map);

  // throws SQLException
  void setHoldability(int holdability);

  // throws SQLException
  int getHoldability();

  // throws SQLException
  Savepoint setSavepoint();

  // throws SQLException
  Savepoint setSavepoint(string name);

  // throws SQLException
  void rollback(Savepoint savepoint);

  // throws SQLException
  void releaseSavepoint(Savepoint savepoint);

  // throws SQLException
  Statement createStatement(int resultSetType, int resultSetConcurrency,
                            int resultSetHoldability);

  // throws SQLException
  PreparedStatement prepareStatement(string sql, int resultSetType,
                      int resultSetConcurrency, int resultSetHoldability);

  // throws SQLException
  CallableStatement prepareCall(string sql, int resultSetType,
                                int resultSetConcurrency,
                                int resultSetHoldability);

  // throws SQLException
  PreparedStatement prepareStatement(string sql, int autoGeneratedKeys);

  // throws SQLException
  PreparedStatement prepareStatement(string sql, int[] columnIndexes);

  // throws SQLException
  PreparedStatement prepareStatement(string sql, string[] columnNames);
}

}
