namespace net.sql {

public enum DatabaseMetaData_procedure {
  ResultUnknown  = 0,
  NoResult       = 1,
  ReturnsResult  = 2,
}

public enum DatabaseMetaData_procedureColumn {
  Unknown = 0,
  In      = 1,
  InOut   = 2,
  Out     = 4,
  Return  = 5,
  Result  = 3,
}

public enum DatabaseMetaData_procedureNull {
  NoNulls         = 0,
  Nullable        = 1,
  NullableUnknown = 2,
}

public enum DatabaseMetaData_column {
  NoNulls         = 0,
  Nullable        = 1,
  NullableUnknown = 2,
}

public enum DatabaseMetaData_bestRow {
  Temporary   = 0,
  Transaction = 1,
  Session     = 2,
}

public enum DatabaseMetaData_bestRow2 {
  Unknown   = 0,
  NotPseudo = 1,
  Pseudo    = 2,
}

public enum DatabaseMetaData_version {
  ColumnUnknown   = 0,
  ColumnNotPseudo = 1,
  ColumnPseudo    = 2,
}

public enum DatabaseMetaData_imported {
  KeyCascade            = 0,
  KeyRestrict           = 1,
  KeySetNull            = 2,
  KeyNoAction           = 3,
  KeySetDefault         = 4,
  KeyInitiallyDeferred  = 5,
  KeyInitiallyImmediate = 6,
  KeyNotDeferrable      = 7,
}

public enum DatabaseMetaData_typeNull {
  NoNulls         = 0,
  Nullable        = 1,
  NullableUnknown = 2,
}

public enum DatabaseMetaData_type {
  PredNone   = 0,
  PredChar   = 1,
  PredBasic  = 2,
  Searchable = 3,
}

public enum DatabaseMetaData_table : short {
  IndexStatistic = 0,
  IndexClustered = 1,
  IndexHashed    = 2,
  IndexOther     = 3,
}

public enum DatabaseMetaData_attribute : short {
  NoNulls         = 0,
  Nullable        = 1,
  NullableUnknown = 2,
}

public enum DatabaseMetaData_sql {
  StateXOpen = 1,
  StateSQL99 = 2,
}

public interface DatabaseMetaData {

  // throws SQLException
  bool allProceduresAreCallable();

  // throws SQLException
  bool allTablesAreSelectable();

  // throws SQLException
  string getURL();

  // throws SQLException
  string getUserName();

  // throws SQLException
  bool isReadOnly();

  // throws SQLException
  bool nullsAreSortedHigh();

  // throws SQLException
  bool nullsAreSortedLow();

  // throws SQLException
  bool nullsAreSortedAtStart();

  // throws SQLException
  bool nullsAreSortedAtEnd();

  // throws SQLException
  string getDatabaseProductName();

  // throws SQLException
  string getDatabaseProductVersion();

  // throws SQLException
  string getDriverName();

  // throws SQLException
  string getDriverVersion();

  int getDriverMajorVersion();

  int getDriverMinorVersion();

  // throws SQLException
  bool usesLocalFiles();

  // throws SQLException
  bool usesLocalFilePerTable();

  // throws SQLException
  bool supportsMixedCaseIdentifiers();

  // throws SQLException
  bool storesUpperCaseIdentifiers();

  // throws SQLException
  bool storesLowerCaseIdentifiers();

  // throws SQLException
  bool storesMixedCaseIdentifiers();

  // throws SQLException
  bool supportsMixedCaseQuotedIdentifiers();

  // throws SQLException
  bool storesUpperCaseQuotedIdentifiers();

  // throws SQLException
  bool storesLowerCaseQuotedIdentifiers();

  // throws SQLException
  bool storesMixedCaseQuotedIdentifiers();

  // throws SQLException
  string getIdentifierQuoteString();

  // throws SQLException
  string getSQLKeywords();

  // throws SQLException
  string getNumericFunctions();

  // throws SQLException
  string getStringFunctions();

  // throws SQLException
  string getSystemFunctions();

  // throws SQLException
  string getTimeDateFunctions();

  // throws SQLException
  string getSearchStringEscape();

  // throws SQLException
  string getExtraNameCharacters();

  // throws SQLException
  bool supportsAlterTableWithAddColumn();

  // throws SQLException
  bool supportsAlterTableWithDropColumn();

  // throws SQLException
  bool supportsColumnAliasing();

  // throws SQLException
  bool nullPlusNonNullIsNull();

  // throws SQLException
  bool supportsConvert();

  // throws SQLException
  bool supportsConvert(int fromType, int toType);

  // throws SQLException
  bool supportsTableCorrelationNames();

  // throws SQLException
  bool supportsDifferentTableCorrelationNames();

  // throws SQLException
  bool supportsExpressionsInOrderBy();

  // throws SQLException
  bool supportsOrderByUnrelated();

  // throws SQLException
  bool supportsGroupBy();

  // throws SQLException
  bool supportsGroupByUnrelated();

  // throws SQLException
  bool supportsGroupByBeyondSelect();

  // throws SQLException
  bool supportsLikeEscapeClause();

  // throws SQLException
  bool supportsMultipleResultSets();

  // throws SQLException
  bool supportsMultipleTransactions();

  // throws SQLException
  bool supportsNonNullableColumns();

  // throws SQLException
  bool supportsMinimumSQLGrammar();

  // throws SQLException
  bool supportsCoreSQLGrammar();

  // throws SQLException
  bool supportsExtendedSQLGrammar();

  // throws SQLException
  bool supportsANSI92EntryLevelSQL();

  // throws SQLException
  bool supportsANSI92IntermediateSQL();

  // throws SQLException
  bool supportsANSI92FullSQL();

  // throws SQLException
  bool supportsIntegrityEnhancementFacility();

  // throws SQLException
  bool supportsOuterJoins();

  // throws SQLException
  bool supportsFullOuterJoins();

  // throws SQLException
  bool supportsLimitedOuterJoins();

  // throws SQLException
  string getSchemaTerm();

  // throws SQLException
  string getProcedureTerm();

  // throws SQLException
  string getCatalogTerm();

  // throws SQLException
  bool isCatalogAtStart();

  // throws SQLException
  string getCatalogSeparator();

  // throws SQLException
  bool supportsSchemasInDataManipulation();

  // throws SQLException
  bool supportsSchemasInProcedureCalls();

  // throws SQLException
  bool supportsSchemasInTableDefinitions();

  // throws SQLException
  bool supportsSchemasInIndexDefinitions();

  // throws SQLException
  bool supportsSchemasInPrivilegeDefinitions();

  // throws SQLException
  bool supportsCatalogsInDataManipulation();

  // throws SQLException
  bool supportsCatalogsInProcedureCalls();

  // throws SQLException
  bool supportsCatalogsInTableDefinitions();

  // throws SQLException
  bool supportsCatalogsInIndexDefinitions();

  // throws SQLException
  bool supportsCatalogsInPrivilegeDefinitions();

  // throws SQLException
  bool supportsPositionedDelete();

  // throws SQLException
  bool supportsPositionedUpdate();

  // throws SQLException
  bool supportsSelectForUpdate();

  // throws SQLException
  bool supportsStoredProcedures();

  // throws SQLException
  bool supportsSubqueriesInComparisons();

  // throws SQLException
  bool supportsSubqueriesInExists();

  // throws SQLException
  bool supportsSubqueriesInIns();

  // throws SQLException
  bool supportsSubqueriesInQuantifieds();

  // throws SQLException
  bool supportsCorrelatedSubqueries();

  // throws SQLException
  bool supportsUnion();

  // throws SQLException
  bool supportsUnionAll();

  // throws SQLException
  bool supportsOpenCursorsAcrossCommit();

  // throws SQLException
  bool supportsOpenCursorsAcrossRollback();

  // throws SQLException
  bool supportsOpenStatementsAcrossCommit();

  // throws SQLException
  bool supportsOpenStatementsAcrossRollback();

  // throws SQLException
  int getMaxBinaryLiteralLength();

  // throws SQLException
  int getMaxCharLiteralLength();

  // throws SQLException
  int getMaxColumnNameLength();

  // throws SQLException
  int getMaxColumnsInGroupBy();

  // throws SQLException
  int getMaxColumnsInIndex();

  // throws SQLException
  int getMaxColumnsInOrderBy();

  // throws SQLException
  int getMaxColumnsInSelect();

  // throws SQLException
  int getMaxColumnsInTable();

  // throws SQLException
  int getMaxConnections();

  // throws SQLException
  int getMaxCursorNameLength();

  // throws SQLException
  int getMaxIndexLength();

  // throws SQLException
  int getMaxSchemaNameLength();

  // throws SQLException
  int getMaxProcedureNameLength();

  // throws SQLException
  int getMaxCatalogNameLength();

  // throws SQLException
  int getMaxRowSize();

  // throws SQLException
  bool doesMaxRowSizeIncludeBlobs();

  // throws SQLException
  int getMaxStatementLength();

  // throws SQLException
  int getMaxStatements();

  // throws SQLException
  int getMaxTableNameLength();

  // throws SQLException
  int getMaxTablesInSelect();

  // throws SQLException
  int getMaxUserNameLength();

  // throws SQLException
  int getDefaultTransactionIsolation();

  // throws SQLException
  bool supportsTransactions();

  // throws SQLException
  bool supportsTransactionIsolationLevel(int level);

  // throws SQLException
  bool supportsDataDefinitionAndDataManipulationTransactions();

  // throws SQLException
  bool supportsDataManipulationTransactionsOnly();

  // throws SQLException
  bool dataDefinitionCausesTransactionCommit();

  // throws SQLException
  bool dataDefinitionIgnoredInTransactions();

  // throws SQLException
  ResultSet getProcedures(string catalog, string schemaPattern,
                          string procedureNamePattern);

  // throws SQLException
  ResultSet getProcedureColumns(string catalog,
                                string schemaPattern,
                                string procedureNamePattern,
                                string columnNamePattern);

  // throws SQLException
  ResultSet getTables(string catalog, string schemaPattern,
                      string tableNamePattern, string[] types);

  // throws SQLException
  ResultSet getSchemas();

  // throws SQLException
  ResultSet getCatalogs();

  // throws SQLException
  ResultSet getTableTypes();

  // throws SQLException
  ResultSet getColumns(string catalog, string schemaPattern,
                       string tableNamePattern, string columnNamePattern);

  // throws SQLException
  ResultSet getColumnPrivileges(string catalog, string schema,
                                string table, string columnNamePattern);

  // throws SQLException
  ResultSet getTablePrivileges(string catalog, string schemaPattern,
                               string tableNamePattern);

  // throws SQLException
  ResultSet getBestRowIdentifier(string catalog, string schema,
                                 string table, int scope, bool nullable);

  // throws SQLException
  ResultSet getVersionColumns(string catalog, string schema,
                              string table);

  // throws SQLException
  ResultSet getPrimaryKeys(string catalog, string schema,
                           string table);

  // throws SQLException
  ResultSet getImportedKeys(string catalog, string schema,
                            string table);

  // throws SQLException
  ResultSet getExportedKeys(string catalog, string schema,
                            string table);

  // throws SQLException
  ResultSet getCrossReference(
       string primaryCatalog, string primarySchema, string primaryTable,
       string foreignCatalog, string foreignSchema, string foreignTable);

  // throws SQLException
  ResultSet getTypeInfo();

  // throws SQLException
  ResultSet getIndexInfo(string catalog, string schema, string table,
                         bool unique, bool approximate);

  // throws SQLException
  bool supportsResultSetType(int type);

  // throws SQLException
  bool supportsResultSetConcurrency(int type, int concurrency);

  // throws SQLException
  bool ownUpdatesAreVisible(int type);

  // throws SQLException
  bool ownDeletesAreVisible(int type);

  // throws SQLException
  bool ownInsertsAreVisible(int type);

  // throws SQLException
  bool othersUpdatesAreVisible(int type);

  // throws SQLException
  bool othersDeletesAreVisible(int type);

  // throws SQLException
  bool othersInsertsAreVisible(int type);

  // throws SQLException
  bool updatesAreDetected(int type);

  // throws SQLException
  bool deletesAreDetected(int type);

  // throws SQLException
  bool insertsAreDetected(int type);

  // throws SQLException
  bool supportsBatchUpdates();

  // throws SQLException
  ResultSet getUDTs(string catalog, string schemaPattern,
                    string typeNamePattern, int[] types);

  // throws SQLException
  Connection getConnection();

  // throws SQLException
  bool supportsSavepoints();

  // throws SQLException
  bool supportsNamedParameters();

  // throws SQLException
  bool supportsMultipleOpenResults();

  // throws SQLException
  bool supportsGetGeneratedKeys();

  // throws SQLException
  ResultSet getSuperTypes(string catalog, string schemaPattern,
                          string typeNamePattern);
    
  // throws SQLException
  ResultSet getSuperTables(string catalog, string schemaPattern,
                           string tableNamePattern);

  // throws SQLException
  ResultSet getAttributes(string catalog, string schemaPattern,
                          string typeNamePattern, string attributeNamePattern);

  // throws SQLException
  bool supportsResultSetHoldability(int holdability);

  // throws SQLException
  int getResultSetHoldability();

  // throws SQLException
  int getDatabaseMajorVersion();

  // throws SQLException
  int getDatabaseMinorVersion();

  // throws SQLException
  int getJDBCMajorVersion();

  // throws SQLException
  int getJDBCMinorVersion();

  // throws SQLException
  int getSQLStateType();

  // throws SQLException
  bool locatorsUpdateCopy();

  // throws SQLException
  bool supportsStatementPooling();
}

}
