namespace net.sql {

public interface PreparedStatement : Statement {

  // throws SQLException
  ResultSet executeQuery();

  // throws SQLException
  int executeUpdate();

  // throws SQLException
  void setNull(int parameterIndex, int sqlType);

  // throws SQLException
  void setBoolean(int parameterIndex, bool x);

  // throws SQLException
  void setByte(int parameterIndex, sbyte x);

  // throws SQLException
  void setShort(int parameterIndex, short x);

  // throws SQLException
  void setInt(int parameterIndex, int x);

  // throws SQLException
  void setLong(int parameterIndex, long x);

  // throws SQLException
  void setFloat(int parameterIndex, float x);

  // throws SQLException
  void setDouble(int parameterIndex, double x);

  // throws SQLException
  void setBigDecimal(int parameterIndex, System.Decimal x);

  // throws SQLException
  void setString(int parameterIndex, string x);

  // throws SQLException
  void setBytes(int parameterIndex, sbyte[] x);

  // throws SQLException
  void setDate(int parameterIndex, System.DateTime x);

  // throws SQLException
  void setTime(int parameterIndex, System.DateTime x);

  // throws SQLException
  void setTimestamp(int parameterIndex, System.DateTime x);

  // throws SQLException
  void setAsciiStream(int parameterIndex, System.IO.BinaryReader x, int length);

  // throws SQLException
  void setUnicodeStream(int parameterIndex, System.IO.BinaryReader x,
                        int length);

  // throws SQLException
  void setBinaryStream(int parameterIndex, System.IO.BinaryReader x,
                       int length);

  // throws SQLException
  void clearParameters();

  // throws SQLException
  void setObject(int parameterIndex, object x, int targetSqlType, int scale);

  // throws SQLException
  void setObject(int parameterIndex, object x, int targetSqlType);

  // throws SQLException
  void setObject(int parameterIndex, object x);

  // throws SQLException
  bool execute();

  // throws SQLException
  void addBatch();

  // throws SQLException
  void setCharacterStream(int parameterIndex,
                          System.IO.StreamReader reader,
                          int length);

  // throws SQLException
  void setRef(int i, Ref x);

  // throws SQLException
  void setBlob(int i, Blob x);

  // throws SQLException
  void setClob(int i, Clob x);

  // throws SQLException
  void setArray(int i, Array x);

  // throws SQLException
  ResultSetMetaData getMetaData();

  // throws SQLException
  void setDate(int parameterIndex, System.DateTime x, System.Globalization.Calendar cal);

  // throws SQLException
  void setTime(int parameterIndex, System.DateTime x, System.Globalization.Calendar cal);

  // throws SQLException
  void setTimestamp(int parameterIndex, System.DateTime x, System.Globalization.Calendar cal);

  // throws SQLException
  void setNull(int paramIndex, int sqlType, string typeName);

  // throws SQLException
  void setURL(int parameterIndex, string x);

  // throws SQLException
  ParameterMetaData getParameterMetaData();
}

}
