namespace net.sql {

public class SQLException : System.Exception {

  private SQLException nextException;

  public SQLException(string reason) : base(reason) {
    if( !(this is SQLWarning) )
    {
      System.IO.TextWriter logger = DriverManager.getLogWriter();
      if( logger != null )
        printStackTrace(logger);
    }
  }

  public SQLException() : base() {
    if( !(this is SQLWarning) )
    {
      System.IO.TextWriter logger = DriverManager.getLogWriter();
      if( logger != null )
        printStackTrace(logger);
    }
  }

  private void printStackTrace(System.IO.TextWriter s) {
    s.WriteLine(Message);
    s.WriteLine(StackTrace);
  }

  public SQLException getNextException() {
    return nextException;
  }

  public void setNextException(SQLException ex) {
    lock(this) {
      SQLException end = this;
      while( end.nextException != null )
        end = end.nextException;
      end.nextException = ex;
    }
  }
}

}
