namespace net.sql {

public interface SQLInput {

  // throws SQLException
  string readString();

  // throws SQLException
  bool readbool();

  // throws SQLException
  sbyte readByte();

  // throws SQLException
  short readShort();

  // throws SQLException
  int readInt();

  // throws SQLException
  long readLong();

  // throws SQLException
  float readFloat();

  // throws SQLException
  double readDouble();

  // throws SQLException
  System.Decimal readBigDecimal();

  // throws SQLException
  sbyte[] readBytes();

  // throws SQLException
  System.DateTime readDate();

  // throws SQLException
  System.DateTime readTime();

  // throws SQLException
  System.DateTime readTimestamp();

  // throws SQLException
  System.IO.StreamReader readCharacterStream();

  // throws SQLException
  System.IO.BinaryReader readAsciiStream();

  // throws SQLException
  System.IO.BinaryReader readBinaryStream();
  
  // throws SQLException
  object readObject();

  // throws SQLException
  Ref readRef();

  // throws SQLException
  Blob readBlob();

  // throws SQLException
  Clob readClob();

  // throws SQLException
  Array readArray();

  // throws SQLException
  bool wasNull();

  // throws SQLException
  string readURL();
}

}
