namespace net.sql {

public interface SQLOutput {

  // throws SQLException
  void writeString(string x);

  // throws SQLException
  void writeBoolean(bool x);

  // throws SQLException
  void writeByte(sbyte x);

  // throws SQLException
  void writeShort(short x);

  // throws SQLException
  void writeInt(int x);

  // throws SQLException
  void writeLong(long x);

  // throws SQLException
  void writeFloat(float x);

  // throws SQLException
  void writeDouble(double x);

  // throws SQLException
  void writeBigDecimal(System.Decimal x);

  // throws SQLException
  void writeBytes(sbyte[] x);

  // throws SQLException
  void writeDate(System.DateTime x);

  // throws SQLException
  void writeTime(System.DateTime x);

  // throws SQLException
  void writeTimestamp(System.DateTime x);

  // throws SQLException
  void writeCharacterStream(System.IO.StreamReader x);

  // throws SQLException
  void writeAsciiStream(System.IO.BinaryReader x);

  // throws SQLException
  void writeBinaryStream(System.IO.BinaryReader x);

  // throws SQLException
  void writeObject(SQLData x);

  // throws SQLException
  void writeRef(Ref x);

  // throws SQLException
  void writeBlob(Blob x);

  // throws SQLException
  void writeClob(Clob x);

  // throws SQLException
  void writeStruct(Struct x);

  // throws SQLException
  void writeArray(net.sql.Array x);

  // throws SQLException
  void writeURL(string x);
}

}
