namespace net.sql {

public enum Statement_RESULT {
  CLOSE_CURRENT_RESULT = 1,
  KEEP_CURRENT_RESULT  = 2,
  CLOSE_ALL_RESULTS    = 3,
}

public enum Statement_INFO {
  SUCCESS_NO_INFO = -2,
  EXECUTE_FAILED  = -3,
}

public enum Statement_GENERATED {
  RETURN_GENERATED_KEYS = 1,
  NO_GENERATED_KEYS     = 2,
}

public interface Statement {

  // throws SQLException
  ResultSet executeQuery(string sql);

  // throws SQLException
  int executeUpdate(string sql);

  // throws SQLException
  void close();

  // throws SQLException
  int getMaxFieldSize();

  // throws SQLException
  void setMaxFieldSize(int max);

  // throws SQLException
  int getMaxRows();

  // throws SQLException
  void setMaxRows(int max);

  // throws SQLException
  void setEscapeProcessing(bool enable);

  // throws SQLException
  int getQueryTimeout();

  // throws SQLException
  void setQueryTimeout(int seconds);

  // throws SQLException
  void cancel();

  // throws SQLException
  SQLWarning getWarnings();

  // throws SQLException
  void clearWarnings();

  // throws SQLException
  void setCursorName(string name);

  // throws SQLException
  bool execute(string sql);

  // throws SQLException
  ResultSet getResultSet();

  // throws SQLException
  int getUpdateCount();

  // throws SQLException
  bool getMoreResults();

  // throws SQLException
  void setFetchDirection(int direction);

  // throws SQLException
  int getFetchDirection();

  // throws SQLException
  void setFetchSize(int rows);

  // throws SQLException
  int getFetchSize();

  // throws SQLException
  int getResultSetConcurrency();

  // throws SQLException
  int getResultSetType();

  // throws SQLException
  void addBatch(string sql);

  // throws SQLException
  void clearBatch();

  // throws SQLException
  int[] executeBatch();

  // throws SQLException
  Connection getConnection();

  // throws SQLException
  bool getMoreResults(int current);

  // throws SQLException
  ResultSet getGeneratedKeys();

  // throws SQLException
  int executeUpdate(string sql, int autoGeneratedKeys);

  // throws SQLException
  int executeUpdate(string sql, int[] columnIndexes);

  // throws SQLException
  int executeUpdate(string sql, string[] columnNames);

  // throws SQLException
  bool execute(string sql, int autoGeneratedKeys);

  // throws SQLException
  bool execute(string sql, int[] columnIndexes);

  // throws SQLException
  bool execute(string sql, string[] columnNames);

  // throws SQLException
  int getResultSetHoldability();
}

}
