namespace netx.sql {

using System;
using net.sql;

[Serializable]
public class EventObject {
  [NonSerialized]
  protected object source;

  public EventObject(object source) {
    this.source = source;
  }

  public object getSource() {
    return source;
  }

  public override string ToString() {
    return this.GetType().FullName + "[source=" + source + "]";
  }
}

[Serializable]
public class ConnectionEvent : EventObject {

  private SQLException sqlException;

  public ConnectionEvent(PooledConnection con) : base(con) {
  }

  public ConnectionEvent(PooledConnection con, SQLException sqlException) :
                                                                 base(con) {
    this.sqlException = sqlException;
  }

  public SQLException getSQLException() {
    return sqlException;
  }
}

}
