namespace netx.sql {

using System;
using System.IO;
using net.sql;

public interface RowSet : ResultSet {

  // throws SQLException
  string getUrl();

  // throws SQLException
  void setUrl(string url);

  // throws SQLException
  object getDataSourceObject();

  // throws SQLException
  void setDataSourceObject(object ds);

  string getUsername();

  // throws SQLException
  void setUsername(string name);

  string getPassword();

  // throws SQLException
  void setPassword(string password);

  int getTransactionIsolation();

  // throws SQLException
  void setTransactionIsolation(int level);

  // throws SQLException
  System.Collections.Hashtable getTypeMap();

  // throws SQLException
  void setTypeMap(System.Collections.Hashtable map);

  string getCommand();

  // throws SQLException
  void setCommand(string cmd);

  bool isReadOnly();

  // throws SQLException
  void setReadOnly(bool value);

  // throws SQLException
  int getMaxFieldSize();

  // throws SQLException
  void setMaxFieldSize(int max);

  // throws SQLException
  int getMaxRows();

  // throws SQLException
  void setMaxRows(int max);

  // throws SQLException
  bool getEscapeProcessing();

  // throws SQLException
  void setEscapeProcessing(bool enable);

  // throws SQLException
  int getQueryTimeout();

  // throws SQLException
  void setQueryTimeout(int seconds);

  // throws SQLException
  void setType(int type);

  // throws SQLException
  void setConcurrency(int concurrency);

  // throws SQLException
  void setNull(int parameterIndex, int sqlType);

  // throws SQLException
  void setNull(int paramIndex, int sqlType, string typeName);

  // throws SQLException
  void setBoolean(int parameterIndex, bool x);

  // throws SQLException
  void setByte(int parameterIndex, sbyte x);

  // throws SQLException
  void setShort(int parameterIndex, short x);

  // throws SQLException
  void setInt(int parameterIndex, int x);

  // throws SQLException
  void setLong(int parameterIndex, long x);

  // throws SQLException
  void setFloat(int parameterIndex, float x);

  // throws SQLException
  void setDouble(int parameterIndex, double x);

  // throws SQLException
  void setBigDecimal(int parameterIndex, System.Decimal x);

  // throws SQLException
  void setString(int parameterIndex, string x);

  // throws SQLException
  void setBytes(int parameterIndex, sbyte[] x);

  // throws SQLException
  void setDate(int parameterIndex, System.DateTime x);

  // throws SQLException
  void setTime(int parameterIndex, System.DateTime x);

  // throws SQLException
  void setTimestamp(int parameterIndex, System.DateTime x);

  // throws SQLException
  void setAsciiStream(int parameterIndex, System.IO.BinaryReader x, int length);

  // throws SQLException
  void setBinaryStream(int parameterIndex, System.IO.BinaryReader x, int length);

  // throws SQLException
  void setCharacterStream(int parameterIndex, System.IO.StreamReader reader, int length);

  // throws SQLException
  void setObject(int parameterIndex, object x, int targetSqlType, int scale);

  // throws SQLException
  void setObject(int parameterIndex, object x, int targetSqlType);

  // throws SQLException
  void setObject(int parameterIndex, object x);

  // throws SQLException
  void setRef(int i, Ref x);

  // throws SQLException
  void setBlob(int i, Blob x);

  // throws SQLException
  void setClob(int i, Clob x);

  // throws SQLException
  void setArray(int i, net.sql.Array x);

  // throws SQLException
  void setDate(int parameterIndex, System.DateTime x, System.Globalization.Calendar cal);

  // throws SQLException
  void setTime(int parameterIndex, System.DateTime x, System.Globalization.Calendar cal);

  // throws SQLException
  void setTimestamp(int parameterIndex, System.DateTime x, System.Globalization.Calendar cal);

  // throws SQLException
  void clearParameters();

  // throws SQLException
  void execute();

  void addRowSetListener(RowSetListener listener);

  void removeRowSetListener(RowSetListener listener);
}

}
